=== proxmox/pbs-api-types/debian/changelog ===
rust-pbs-api-types (0.2.2) bookworm; urgency=medium

  * add garbage collection atime safety check flag.
  * add option to set GC chunk cleanup atime cutoff.
  * fix #5379: add `default` field for all realm types.
  * sync: add sync encrypted/verified snapshots only flags.
  * add garbage collection cache capacity tuning option.

 -- Proxmox Support Team <support@proxmox.com>  Sat, 05 Apr 2025 17:22:09 +0200

rust-pbs-api-types (0.2.1) bookworm; urgency=medium

  * metrics: relax influx organization and bucket length
  * tape backup job: add worker threads option
  * user: add boolean-schema for regenerate-api-token flag

 -- Proxmox Support Team <support@proxmox.com>  Wed, 02 Apr 2025 15:34:49 +0200

rust-pbs-api-types (0.2.0) bookworm; urgency=medium

  * imported from proxmox-backup repository

 -- Proxmox Support Team <support@proxmox.com>  Wed, 22 Jan 2025 09:40:51 +0100
